//----------------------------------------------------------------------------
// SVG Viewer - Version 1.0
// A library of SVG renderer
// Copyright (C) 2008 Witold Jaworski
// Contact:	witold.jaworski@airplanes3d.net
//			http://airplanes3d.net
// 
// Contains elements from:
//			AGG - a graphic library (Copyright Maxim Shemanarev, mcseem@antigrain.com)
//          http://antigrain.com
// Uses functions from:
//          Expat - a XML parser library (Copyright James Clark)
// 
// SVG Viewer is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// SVG Viewer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with SVG Viewer; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA 02110-1301, USA.
//----------------------------------------------------------------------------

#ifndef SVG_DEFS_INCLUDED
#include "svg_group.h"
#define SVG_DEFS_INCLUDED

namespace svg
{
//////////////////////////////////////////////////////////////////////
// defs: a group of the definitions  
//	
//////////////////////////////////////////////////////////////////////
class defs : public group 
{
	public:
		//////////////////////////////////////////////////////////////////////
		// constructor and overriden virtual methods
		//////////////////////////////////////////////////////////////////////

		defs(element *parent, unsigned level): group(parent, level) {}

		virtual const char * tag() {return "defs";};

		//////////////////////////////////////////////////////////////////////
		// Other methods and fields
		//////////////////////////////////////////////////////////////////////

		//request handler:
		virtual handle on_request(request &req) 
		{
			switch(req.type())
			{
			case request::measure:
			case request::render:
				return skip(req); //no render, no measure of its content!

			default: 
				return group::on_request(req);
			}//switch
		}

	protected:
}; //defs

}; //namespace svg
#endif SVG_DEFS_INCLUDED
