//----------------------------------------------------------------------------
// SVG Viewer - Version 1.0
// A library of SVG renderer
// Copyright (C) 2008 Witold Jaworski
// Contact:	witold.jaworski@airplanes3d.net
//			http://airplanes3d.net
// 
// Contains elements from:
//			AGG - a graphic library (Copyright Maxim Shemanarev, mcseem@antigrain.com)
//          http://antigrain.com
// Uses functions from:
//          Expat - a XML parser library (Copyright James Clark)
// 
// SVG Viewer is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// SVG Viewer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with SVG Viewer; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA 02110-1301, USA.
//----------------------------------------------------------------------------

#ifndef SVG_POLY_INCLUDED
#include "svg_path.h"
#define SVG_POLY_INCLUDED

namespace svg
{
//////////////////////////////////////////////////////////////////////
// polyline: open sequence of connected lines
//////////////////////////////////////////////////////////////////////
class polyline : public path 
{
	public:
		//////////////////////////////////////////////////////////////////////
		// constructor and overriden virtual methods
		//////////////////////////////////////////////////////////////////////

		polyline(element *parent, unsigned level): path(parent, level) 
		{}

		virtual void on_attribute(parser &prs, const char * name, const char *value)
		{
			if (strcmp(name, "points") == 0) 
			{	
				m_path = prs.parse_points(value,false);
			}
			else 
				{//forward this to the base class
					path::on_attribute(prs,name,value);
				}
		}
		
		virtual const char * tag() {return "polyline";};

	protected:

}; //polyline

//////////////////////////////////////////////////////////////////////
// polygon: open sequence of connected lines
//////////////////////////////////////////////////////////////////////
class polygon : public path 
{
	public:
		//////////////////////////////////////////////////////////////////////
		// constructor and overriden virtual methods
		//////////////////////////////////////////////////////////////////////
		polygon(element *parent, unsigned level): path(parent, level) 
		{}

		virtual void on_attribute(parser &prs, const char * name, const char *value)
		{
			if (strcmp(name, "points") == 0) 
			{	
				m_path = prs.parse_points(value,true);
			}
			else 
				{//forward this to the base class
					path::on_attribute(prs,name,value);
				}
		}
		
		virtual const char * tag() {return "polygon";};

	protected:

}; //polygon

}; //namespace svg
#endif SVG_POLY_INCLUDED
