//----------------------------------------------------------------------------
// SVG Viewer - Version 1.0
// A library of SVG renderer
// Copyright (C) 2008 Witold Jaworski
// Contact:	witold.jaworski@airplanes3d.net
//			http://airplanes3d.net
// 
// Contains elements from:
//			AGG - a graphic library (Copyright Maxim Shemanarev, mcseem@antigrain.com)
//          http://antigrain.com
// Uses functions from:
//          Expat - a XML parser library (Copyright James Clark)
// 
// SVG Viewer is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// SVG Viewer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with SVG Viewer; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA 02110-1301, USA.
//----------------------------------------------------------------------------
#include "svg_exception.h"
#include "svg_request.h"
#include "svg_styleset.h"
#include "svg_element.h"

namespace svg
{

	//Returns an element, assigned to a handle
	//Arguments:
	//	id:				a handle to an element, obtained from get_id()
	//	expected_class:	optional: the name of the expected class ("text", "ext:earray", etc.)
	//					used for rudimentary type checking. Can be NULL, when don't care
	element  *request::get_element(handle id, const char *expected_class)
	{ 
		if (m_elems && id < (*m_elems).size()) 
		{
			element *e = (*m_elems)[id].elm; 
			if (expected_class && e)
			{
				if (e->is_of(expected_class)) 
					return e;
				else
					return NULL; //element is not of the expected class!
			}
			else
			{
				return e;
			}
		}
		else 
			return NULL;
	}

} // namespace svg